/* tr_insert - insert a single node in tree (recursive version) */
#include "tree.h"
void tr_insert(plt, pn, cmpfn)
	TR_NODE **plt;		/* ptr to link-in of tree or subtree */
	TR_NODE *pn;		/* ptr to node to be inserted */
	int (*cmpfn)();		/* ptr to comparison function */
	{
	TR_NODE *pt;		/* ptr to tree (or subtree) */
	int cmp;			/* result of key comparison; neg, zero, or pos */

	pt = *plt;			/* pt now pts to current tree (if any) */
	if (pt == NULL)		/* if plt pointed to a null pointer, */
		{
		pn->left = pn->right = NULL;	/* has no sub trees yet */
		*plt = pn;		/* then this is the place to install pn; do so */
		}
	else if ((cmp = (*cmpfn)(pn, pt)) == 0)	/* if already in tree, */
		return;								/* then don't install */
	else if (cmp < 0)				/* if node's key compares low */
		TR_INSERT(&pt->left, pn, cmpfn);	/* then insert in left tree */
	else							/* otherwise, */
		TR_INSERT(&pt->right, pn, cmpfn);	/* insert in right tree */
	}
